import java.awt.*;
import java.awt.event.*;

public class arrow extends Frame implements ActionListener, WindowListener
{

private ArrowCanvas sheet;
    private InputFrame pnorth;
    private int[][] adjM =new int[12][12];
    private int[][] szintek =new int[12][12];
    Button inpu,bevi,szintez,pert;
    private Node[] nodes = new Node[12];
    private int numLev,pertLev;
    private Label label;
    Panel psouth = new Panel();
    //    private int[] times ={0,0,0,0,0,0,0,0,0,0,0,0};
public arrow() {
        super("PERT simulation");
        setSize(800,600);
	setLayout(new BorderLayout());
	sheet = new ArrowCanvas();
	add(sheet,"Center");
	addWindowListener(this);
	inpu =new Button("Input ablak fel");
	psouth.add(inpu);
	inpu.addActionListener(this);
	bevi=new Button("Adatok bevitele");
	psouth.add(bevi);
	bevi.addActionListener(this);
	szintez=new Button("Szintekre bonts");
	psouth.add(szintez);
	szintez.addActionListener(this);
	pert=new Button("PERT lps");
	psouth.add(pert);
	pert.addActionListener(this);	
	label=new Label("Haliho!",Label.CENTER);
	psouth.add(label);
	add(psouth,"South");
	for(int i= 0;i<12;i++)
	    nodes[i] = new Node(i,0);
	show();
}


        


public void windowClosed(WindowEvent event)
    	{ 	System.out.println("Activate windowClosed method");    	}
    	public void windowDeiconified(WindowEvent event)
    	{   System.out.println("Activate windowDeiconified");  	}
    	public void windowIconified(WindowEvent event)
    	{   System.out.println("Activate windowIconified");		}
    	public void windowActivated(WindowEvent event)
    	{   System.out.println("Activate windowActivated");		}
    	public void windowDeactivated(WindowEvent event)
    	{   System.out.println("Activate windowDeactivated");	}

    	public void windowOpened(WindowEvent event)
    	{   System.out.println("Activate windowOpened");		}
    	public void windowClosing(WindowEvent event)    	{
		System.out.println("Activate windowClosing");
   		dispose();
    		System.exit(0);
    	}

    	public static void main(String [] args)    {
		arrow f = new arrow ();
    	}
    public  void actionPerformed(ActionEvent e){
	int ind;
	if(e.getSource()==inpu)
	pnorth = new InputFrame();
	else if (e.getSource()==bevi){
	adjM = pnorth.getAdj();
	for(int i=0;i<12;i++){
	    nodes[i].setTime(0);
	    nodes[i].setUpdated(false);
	}
	    sheet.makeSzintAbra(adjM,szintek,numLev,nodes,false);
	}
	else if (e.getSource()==szintez){
	    szintek =determineLevels(adjM);
	    numLev=0;
	    while(numLev<12 && szintek[numLev][0]!=0)
		numLev++;
	    pertLev=numLev-1;
	    sheet.makeSzintAbra(adjM,szintek,numLev,nodes,true);
	    for(int i=0;i<12;i++)
		for(int j=0;j<12;j++)
		    System.out.print(" "+szintek[i][j]+" ");
	}
	else if(e.getSource()==pert){
	    for(int i=0;i<12;i++)
		nodes[i].setUpdated(false);
	    if(pertLev<1){
		label.setText("Nincs tbb szint, kszen vagyunk.");
		label.invalidate();
		validate();
	    }
	    else {
		label.setText(""+(numLev-pertLev)+". szintrl javtunk.");
		label.invalidate();
		validate();
		ind=0;
		while(ind<12 && szintek[pertLev][ind]!=0){
		    javit(szintek[pertLev][ind]-1);
		    ind++;
		}
		pertLev--;
		sheet.repaint();
	    }
	}
    }
	public int[][] determineLevels(int[][] adj){
	    int[][] sz = new int[12][12];
	    int[][] temp = new int[12][12];
	    int count,lev,rowSum,ind;
	    lev=0;
	    count=0;
	    try{
	    for(int i=0;i<12;i++)
		for(int j=0;j<12;j++)
		    temp[i][j]=adj[i][j];
	    while(count<12){
		ind=0;
		for(int i=0;i<12;i++){
		    rowSum=0;
		    for(int j=0;j<12;j++)
			rowSum=rowSum+temp[i][j];
		    if(rowSum==0){
			sz[lev][ind]=i+1;
			ind++;
			count++;
			nodes[i].setLev(lev);
			for(int k=0;k<12;k++)
			    temp[i][k]=-1;
		    }
		}
		ind=0;
		while(ind<12 && sz[lev][ind]!=0){
		    for(int i=0;i<12;i++)
			temp[i][sz[lev][ind]-1]=0;
		    ind++;
		}
		lev++;
	    }}catch(ArrayIndexOutOfBoundsException ex)
		{label.setText("Kr van a grfban!");
		label.invalidate();
		validate();
		}
	    return sz;
	}
    public void javit(int nd){
	for(int j=0;j<12;j++){
	    if(adjM[nd][j]>0)
		if(nodes[j].getNumTime()-nodes[nd].getNumTime()<adjM[nd][j]){
		    nodes[j].setTime(nodes[nd].getNumTime()+adjM[nd][j]);
		    nodes[j].setUpdated(true);
		}
	}
    }
}
